<template>
    <v-container>
        <validation-observer ref="observer">
            <v-row dense>
                <v-col>
                    <div class="field-label">{{ $t('first_name' )}}</div>
                    <validation-provider v-slot="{ errors }" name="first_name" rules="required">
                        <v-text-field
                            v-model="localValue.first_name"
                            :error-messages="errors"
                            hide-details="auto"
                            outlined
                        ></v-text-field>
                    </validation-provider>
                </v-col>
                <v-col>
                    <div class="field-label">{{ $t('last_name' )}}</div>
                    <validation-provider v-slot="{ errors }" name="last_name" rules="required">
                        <v-text-field
                            v-model="localValue.last_name"
                            :error-messages="errors"
                            hide-details="auto"
                            outlined
                        ></v-text-field>
                    </validation-provider>
                </v-col>
                <v-col cols="12">
                    <div class="field-label">{{ $t('mobile') }}</div>
                    <validation-provider v-slot="{ errors }" name="mobile" rules="required|mobile">
                        <v-tel-input
                            v-model="localValue.mobile"
                            defaultCountry="my"
                            :placeholder="$t('mobile')"
                            :errors="errors"
                            hide-details="auto"
                        ></v-tel-input>
                    </validation-provider>
                </v-col>
                <v-col>
                    <div class="field-label">{{ $t('company') }}</div>
                    <v-text-field
                        v-model="localValue.company"
                        hide-details="auto"
                        outlined
                    ></v-text-field>
                </v-col>
                <v-col cols="12">
                    <div class="field-label">{{ $t('address1') }}</div>
                    <validation-provider v-slot="{ errors }" name="address1" rules="required">
                        <v-text-field
                            v-model="localValue.address_1"
                            :error-messages="errors"
                            hide-details="auto"
                            outlined
                        ></v-text-field>
                    </validation-provider>
                </v-col>
                <v-col cols="12">
                    <div class="field-label">{{ $t('address2' )}}</div>
                    <v-text-field
                        v-model="localValue.address_2"
                        hide-details="auto"
                        outlined
                    ></v-text-field>
                </v-col>
                <v-col cols="6">
                    <div class="field-label">{{ $t('city' )}}</div>
                    <validation-provider v-slot="{ errors }" name="city" rules="required">
                        <v-text-field
                            v-model="localValue.city"
                            :error-messages="errors"
                            hide-details="auto"
                            outlined
                        ></v-text-field>
                    </validation-provider>
                </v-col>
                <v-col cols="6">
                    <div class="field-label">{{ $t('state' )}}</div>
                    <validation-provider v-slot="{ errors }" name="state" rules="required">
                        <v-text-field
                            v-model="localValue.state"
                            :error-messages="errors"
                            hide-details="auto"
                            outlined
                        ></v-text-field>
                    </validation-provider>
                </v-col>
                <v-col cols="6">
                    <div class="field-label">{{ $t('country' )}}</div>
                    <validation-provider v-slot="{ errors }" name="country" rules="required">
                        <v-text-field
                            v-model="localValue.country"
                            :error-messages="errors"
                            hide-details="auto"
                            outlined
                        ></v-text-field>
                    </validation-provider>
                </v-col>
                <v-col cols="6">
                    <div class="field-label">{{ $t('postcode' )}}</div>
                    <validation-provider v-slot="{ errors }" name="postcode" rules="required">
                        <v-text-field
                            v-model="localValue.postcode"
                            :error-messages="errors"
                            hide-details="auto"
                            outlined
                        ></v-text-field>
                    </validation-provider>
                </v-col>
            </v-row>
        </validation-observer>
    </v-container>
</template>

<script>
    import VTelInput from "../VTelInput";
    import { ValidationObserver, ValidationProvider } from "vee-validate";

    export default {
        name: 'AddressForm',
        components: {
            VTelInput,
            ValidationObserver,
            ValidationProvider
        },
        props: {
            value: {
                type: Object,
                required: true
            }
        },
        computed: {
            localValue: {
                get() {
                    return this.value;
                },
                set(val) {
                    this.$emit('input', val);
                }
            }
        },
        methods: {
            validate() {
                return this.$refs.observer.validate();
            }
        }
    }
</script>

<style scoped>

</style>
